import { XPromiseError } from './error';
import { XPromiseExecutor } from './rawInfo';
import { XPromiseErrorCodeEnum } from './utils';

export { XPromiseError, XPromiseErrorCodeEnum };
/** promise拓展 */
export declare class XPromise<T> implements Promise<T> {
    private __RAW_CONTEXT__;
    constructor(executorRaw: XPromiseExecutor<T>);
    get then(): <TResult1 = T, TResult2 = never>(onfulfilled?: ((value: T) => TResult1 | PromiseLike<TResult1>) | null | undefined, onrejected?: ((reason: any) => TResult2 | PromiseLike<TResult2>) | null | undefined) => Promise<TResult1 | TResult2>;
    get catch(): <TResult = never>(onrejected?: ((reason: any) => TResult | PromiseLike<TResult>) | null | undefined) => Promise<T | TResult>;
    get finally(): (onfinally?: (() => void) | null | undefined) => Promise<T>;
    get [Symbol.toStringTag](): string;
    /** 超时设置 */
    timeout: (time: number) => XPromise<T>;
}
